package xyz.tbvns.core;

import xyz.tbvns.core.Objects.Level;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class DataManager {
    public static List<String> decodeLocalLevel() throws IOException {
        List<String> data = new ArrayList<>();
        File geometryDash = new File(FilesLocations.getGeometryDashFolder());
        String[] files = geometryDash.list();
        for (String file : files) {
            if (file.contains("CCLocalLevels") && file.endsWith(".dat")) {
                File fileToDecode = new File(geometryDash.getPath() + "/" + file);
                data.add(new String(Decoder.decodeFile(fileToDecode)));
            }
        }
        return data;
    }

    public static List<Level> getLevels() throws IOException {
        List<Level> levelList = new ArrayList<>();
        String rawData = XmlUtils.beautify(decodeLocalLevel().get(1));
        String[] lineData = rawData.split("\n");
        Level level = new Level();
        int endTime = 0;
        for (int i = 0; i < lineData.length; i++) {
            String line = lineData[i];
            if (line.startsWith("<k>k_") && line.endsWith("</k>")) {
                level = new Level();
            } else
            if (line.equals("<k>k2</k>")) {
                level.setName(lineData[i+1].replace("<s>", "").replace("</s>", ""));
            } else
            if (line.equals("<k>k4</k>")) {
                level.setEncodedLevelString(lineData[i+1].replace("<s>", "").replace("</s>", ""));
            } else
            if (line.equals("<k>k5</k>")) {
                level.setCreator(lineData[i+1].replace("<s>", "").replace("</s>", ""));
            } else
            if (line.equals("</d>")) {
                endTime++;
                if (endTime % 2 == 0) {
                    levelList.add(level);
                }
            } else
            if (line.equals("<k>LLM_02</k>")) {
                break;
            }
        }
        return levelList;
    }
}
